--AH:ScriptId=b2b02513-9df0-4641-846e-83acb0a995ee;2801
CREATE TABLE [ReleaseConfigurationFiles]
(
	[Application_Id] INT NOT NULL,
	[Release_Number] RELEASENUMBER NOT NULL,
	[ConfigurationFile_Id] INT NOT NULL,
	[Version_Number] INT NOT NULL,

	CONSTRAINT [FK__ReleaseConfigurationFiles__Releases]
		FOREIGN KEY ([Application_Id], [Release_Number])
		REFERENCES [Releases] ([Application_Id], [Release_Number]),

	CONSTRAINT [FK__ReleaseConfigurationFiles__ConfigurationFiles]
		FOREIGN KEY ([ConfigurationFile_Id])
		REFERENCES [ConfigurationFiles] ([ConfigurationFile_Id]),

	CONSTRAINT [PK__ReleaseConfigurationFiles]
		PRIMARY KEY ([Application_Id], [Release_Number], [ConfigurationFile_Id]),

	CONSTRAINT [CK__ReleaseConfigurationFiles__Version_Number]
		CHECK ([Version_Number] > 0)
)

INSERT INTO [ReleaseConfigurationFiles]
(
	[Application_Id],
	[Release_Number],
	[ConfigurationFile_Id],
	[Version_Number]
)
SELECT [Application_Id],
       [Release_Number],
	   [ConfigurationFile_Id],
	   MAX([Version_Number])
  FROM [ConfigurationFileVersions]
 GROUP BY [Application_Id], [Release_Number], [ConfigurationFile_Id]
