--AH:ScriptId=277ddecf-4399-4283-bd38-d6bf74655400;2834
ALTER TABLE [Builds]
	ADD [Build_Sequence] INT

GO

UPDATE B
   SET B.[Build_Sequence] = BS.[Build_Sequence]
  FROM [Builds] B
       INNER JOIN (SELECT [Application_Id],
                          [Release_Number],
	                      [Build_Number],
	                      [Build_Sequence] = CAST(ROW_NUMBER() OVER (PARTITION BY [Application_Id], [Release_Number] ORDER BY [CreatedOn_Date]) AS INT)
                     FROM [Builds]) BS
			   ON BS.[Application_Id] = B.[Application_Id]
			  AND BS.[Release_Number] = B.[Release_Number]
			  AND BS.[Build_Number] = B.[Build_Number]

ALTER TABLE [Builds]
	ALTER COLUMN [Build_Sequence] INT NOT NULL

GO

CREATE NONCLUSTERED INDEX [IX__Builds__Build_Sequence]
	ON [Builds] ([Application_Id], [Release_Number], [Build_Sequence] DESC)

ALTER TABLE [Builds]
	ADD CONSTRAINT [UQ__Builds__Build_Sequence]
		UNIQUE ([Application_Id], [Release_Number], [Build_Sequence])