--AH:ScriptId=a092c89b-67b8-478f-9a52-747dadbc5ca3;3022

INSERT [Tasks] ([Task_Id], [Task_Name], [Application_Scopeable_Indicator], [Environment_Scopeable_Indicator])
SELECT 100, 'Admin_ConfigureBuildMaster', 'N', 'N' UNION ALL
SELECT 101, 'Admin_ManageApplications', 'N', 'N' UNION ALL
SELECT 102, 'Applications_Manage', 'Y', 'N' UNION ALL
SELECT 103, 'Applications_View', 'Y', 'N' UNION ALL
SELECT 104, 'ChangeControls_Manage', 'Y', 'Y' UNION ALL
SELECT 105, 'ConfigurationFiles_Deploy', 'Y', 'Y' UNION ALL
SELECT 106, 'ConfigurationFiles_EditInstance', 'Y', 'Y' UNION ALL
SELECT 107, 'ConfigurationFiles_ViewInstance', 'Y', 'Y' UNION ALL
SELECT 108, 'Environments_Manage', 'N', 'Y' UNION ALL
SELECT 109, 'Environments_View', 'N', 'Y' UNION ALL
SELECT 110, 'Issues_Manage', 'Y', 'N' UNION ALL
SELECT 111, 'Notes_Manage', 'Y', 'N' UNION ALL
SELECT 112, 'Pipelines_Manage', 'Y', 'N' UNION ALL
SELECT 113, 'Plans_Manage', 'Y', 'Y' UNION ALL
SELECT 114, 'Plans_ViewContents', 'Y', 'Y' UNION ALL
SELECT 115, 'ReleasePackages_Create', 'Y', 'N' UNION ALL
SELECT 116, 'ReleasePackages_Deploy', 'Y', 'Y' UNION ALL
SELECT 117, 'ReleasePackages_Force', 'Y', 'Y' UNION ALL
SELECT 118, 'ReleasePackages_Manage', 'Y', 'N' UNION ALL
SELECT 119, 'ReleasePackages_ViewDeploymentDebugLogs', 'Y', 'Y' UNION ALL
SELECT 120, 'ReleasePackages_ViewDeploymentLogs', 'Y', 'Y' UNION ALL
SELECT 121, 'Releases_Manage', 'Y', 'N' UNION ALL
SELECT 122, 'ScriptAssets_Manage', 'Y', 'N' UNION ALL
SELECT 123, 'ScriptAssets_ViewContents', 'Y', 'N' UNION ALL
SELECT 124, 'SqlScripts_Deploy', 'Y', 'Y' UNION ALL
SELECT 125, 'SqlScripts_Manage', 'Y', 'N' UNION ALL
SELECT 126, 'SqlScripts_ViewContents', 'Y', 'N'


ALTER TABLE [Roles]
  ADD [Role_Description] VARCHAR(MAX) NULL,
      [Application_Scopeable_Indicator] YNINDICATOR NULL,
      [Environment_Scopeable_Indicator] YNINDICATOR NULL
GO

INSERT [Roles] ([Role_Name], [Role_Description], [Application_Scopeable_Indicator], [Environment_Scopeable_Indicator])
   SELECT 'Administer', 'Allows unrestricted access to all functionality within BuildMaster.', 'N', 'N' UNION ALL
   SELECT 'Coordinate Releases', 'Allows application overview and release management functionality for an application.', 'Y', 'N' UNION ALL
   SELECT 'Manage Application', 'Allows full managerial and deployment access within the context of an application.', 'Y', 'N' UNION ALL
   SELECT 'View Application', 'Allows view access within the context of an application.', 'Y', 'N' UNION ALL
   SELECT 'Deploy to Environment', 'Allows environment-specific deployment functionality within the context of an application.', 'Y', 'Y'
GO

INSERT [RoleTasks] ([Role_Id], [Task_Id])
  SELECT [Role_Id], [Task_Id] FROM [Roles], [Tasks]
   WHERE [Role_Name] = 'Administer'
     AND [Task_Id] >= 100

INSERT [RoleTasks] ([Role_Id], [Task_Id])
  SELECT [Role_Id], [Task_Id] FROM [Roles], [Tasks]
   WHERE [Role_Name] = 'Coordinate Releases'
     AND [Task_Id] >= 100
     AND [Task_Id] IN (103,104,110,111,112,113,114,115,117,118,119,120,121,122,123,124)

INSERT [RoleTasks] ([Role_Id], [Task_Id])
  SELECT [Role_Id], [Task_Id] FROM [Roles], [Tasks]
   WHERE [Role_Name] = 'Manage Application'
     AND [Task_Id] >= 100
     AND [Task_Id] NOT IN (100,101,108,109)

INSERT [RoleTasks] ([Role_Id], [Task_Id])
  SELECT [Role_Id], [Task_Id] FROM [Roles], [Tasks]
   WHERE [Role_Name] = 'View Application'
     AND [Task_Id] >= 100
     AND [Task_Id] IN (103,114,123)

INSERT [RoleTasks] ([Role_Id], [Task_Id])
  SELECT [Role_Id], [Task_Id] FROM [Roles], [Tasks]
   WHERE [Role_Name] = 'Deploy to Environment'
     AND [Task_Id] >= 100
     AND [Task_Id] IN (105,106,107,113,114,116,117,119,120,124)
GO

DECLARE @Map TABLE ([From_Name] VARCHAR(50) NOT NULL, [To_Name] VARCHAR(50) NULL, [From_Id] INT NULL, [To_Id] INT NULL)

INSERT @Map ([From_Name], [To_Name])
		  SELECT 'Admin_AdministrativeEdits', 'Admin_ConfigureBuildMaster'
UNION ALL SELECT 'Admin_Configure', 'Admin_ConfigureBuildMaster'
UNION ALL SELECT 'Admin_ControlService', 'Admin_ConfigureBuildMaster'
UNION ALL SELECT 'Admin_ManageExtensions', 'Admin_ConfigureBuildMaster'
UNION ALL SELECT 'Admin_ManageLicense', 'Admin_ConfigureBuildMaster'
UNION ALL SELECT 'Admin_ManageSecurity', 'Admin_ConfigureBuildMaster'
UNION ALL SELECT 'Admin_ViewBuildMasterEvents', 'Admin_ConfigureBuildMaster'
UNION ALL SELECT 'Applications_CreateApplication', 'Admin_ManageApplications'
UNION ALL SELECT 'Applications_EditApplication', 'Applications_Manage'
UNION ALL SELECT 'Applications_EditDeployable', 'Applications_Manage'
UNION ALL SELECT 'Applications_PurgeApplication', 'Admin_ManageApplications'
UNION ALL SELECT 'Applications_ViewOverview', 'Applications_View'
UNION ALL SELECT 'Builds_CreateBuild', 'ReleasePackages_Create'
UNION ALL SELECT 'Builds_ExecuteBuild', 'ReleasePackages_Deploy'
UNION ALL SELECT 'Builds_ForceBuild', 'ReleasePackages_Force'
UNION ALL SELECT 'Builds_ManageBuildSchedules', 'Applications_Manage'
UNION ALL SELECT 'Builds_OverridePromotionStatus', 'ReleasePackages_Force'
UNION ALL SELECT 'Builds_PromoteBuild', 'ReleasePackages_Deploy'
UNION ALL SELECT 'Builds_ReExecuteBuild', 'ReleasePackages_Deploy'
UNION ALL SELECT 'Builds_RejectBuild', 'ReleasePackages_Manage'
UNION ALL SELECT 'Builds_ViewArtifact', 'Applications_View'
UNION ALL SELECT 'Builds_ViewBuildHistory', 'Applications_View'
UNION ALL SELECT 'Builds_ViewBuildOverview', 'Applications_View'
UNION ALL SELECT 'Builds_ViewDebugLogs', 'ReleasePackages_ViewDeploymentDebugLogs'
UNION ALL SELECT 'Builds_ViewExecutionDetails', 'ReleasePackages_ViewDeploymentLogs'
UNION ALL SELECT 'Builds_ViewPromotionDetails', 'ReleasePackages_ViewDeploymentLogs'
UNION ALL SELECT 'ChangeControls_ManageChangeControls', 'ChangeControls_Manage'
UNION ALL SELECT 'ChangeControls_PerformAnyChangeControls', 'ChangeControls_Manage'
UNION ALL SELECT 'ChangeControls_ViewChangeControls', 'Applications_View'
UNION ALL SELECT 'ConfigurationFiles_DeployConfigurationFiles', 'ConfigurationFiles_Deploy'
UNION ALL SELECT 'ConfigurationFiles_EditConfigurationFile', 'ConfigurationFiles_EditInstance'
UNION ALL SELECT 'ConfigurationFiles_ManageConfigurationFiles', 'Applications_Manage'
UNION ALL SELECT 'ConfigurationFiles_ViewConfigurationFile', 'ConfigurationFiles_ViewInstance'
UNION ALL SELECT 'DatabaseChangeScripts_DeployChangeScript', 'SqlScripts_Deploy'
UNION ALL SELECT 'DatabaseChangeScripts_ManageChangeScripts', 'SqlScripts_Manage'
UNION ALL SELECT 'DatabaseChangeScripts_ManageDatabaseProviders', 'Applications_Manage'
UNION ALL SELECT 'DatabaseChangeScripts_ViewChangeScript', 'SqlScripts_ViewContents'
UNION ALL SELECT 'DatabaseChangeScripts_ViewDatabaseProvider', NULL
UNION ALL SELECT 'Environments_ManageEnvironments', 'Environments_Manage'
UNION ALL SELECT 'Environments_ManageServers', 'Environments_Manage'
UNION ALL SELECT 'Environments_ViewEnvironment', 'Environments_View'
UNION ALL SELECT 'Environments_ViewServer', 'Environments_View'
UNION ALL SELECT 'Events_ManageAllNotifiers', 'Admin_ConfigureBuildMaster'
UNION ALL SELECT 'Events_ManageOwnNotifiers', NULL
UNION ALL SELECT 'Issues_CloseIssue', 'Issues_Manage'
UNION ALL SELECT 'Issues_CreateIssue', 'Issues_Manage'
UNION ALL SELECT 'Issues_DeleteIssue', 'Issues_Manage'
UNION ALL SELECT 'Issues_EditIssue', 'Issues_Manage'
UNION ALL SELECT 'Issues_SyncIssues', 'Issues_Manage'
UNION ALL SELECT 'Issues_ViewIssue', 'Applications_View'
UNION ALL SELECT 'Plans_ManageGlobalPlans', 'Plans_Manage'
UNION ALL SELECT 'Plans_ManagePlans', 'Plans_Manage'
UNION ALL SELECT 'Plans_ViewActionDetails', 'Plans_Manage'
UNION ALL SELECT 'Plans_ViewGlobalPlans', 'Plans_ViewContents'
UNION ALL SELECT 'Plans_ViewPlan', 'Plans_ViewContents'
UNION ALL SELECT 'Providers_DeleteProvider', 'Admin_ConfigureBuildMaster'
UNION ALL SELECT 'Providers_ManageProviders', 'Admin_ConfigureBuildMaster'
UNION ALL SELECT 'Releases_AddNote', 'Notes_Manage'
UNION ALL SELECT 'Releases_DeleteNote', 'Notes_Manage'
UNION ALL SELECT 'Releases_EditNote', 'Notes_Manage'
UNION ALL SELECT 'Releases_ManageReleases', 'Releases_Manage'
UNION ALL SELECT 'Releases_ViewReleaseOverview', 'Applications_View'
UNION ALL SELECT 'Scripts_ManageScripts', 'ScriptAssets_Manage'
UNION ALL SELECT 'Scripts_ViewScripts', 'ScriptAssets_ViewContents'
UNION ALL SELECT 'Variables_CreateOrUpdateVariables', NULL
UNION ALL SELECT 'Workflows_ManageWorkflows', 'Pipelines_Manage'

UPDATE @Map
   SET [From_Id] = T_FROM.[Task_Id],
       [To_Id] = T_TO.[Task_Id]
  FROM @Map
    INNER JOIN [Tasks] T_FROM ON T_FROM.[Task_Name] = [From_Name]
    INNER JOIN [Tasks] T_TO ON T_TO.[Task_Name] = [To_Name]

DECLARE @DistinctRoleTasks TABLE ([Role_Id] INT, [Task_Id] INT)

INSERT @DistinctRoleTasks ([Role_Id], [Task_Id])
  SELECT RT.[Role_Id], M.[To_Id]
    FROM [RoleTasks] RT
   INNER JOIN @Map M ON RT.[Task_Id] = M.[From_Id]

DELETE [RoleTasks] WHERE [Task_Id] < 100

INSERT [RoleTasks] ([Role_Id], [Task_Id])
SELECT DISTINCT [Role_Id], [Task_Id] 
  FROM @DistinctRoleTasks


DELETE [Tasks] WHERE [Task_Id] < 100