IF OBJECT_ID('ABS_WEEK_NUMBER') IS NOT NULL DROP FUNCTION ABS_WEEK_NUMBER
GO
CREATE FUNCTION ABS_WEEK_NUMBER
(
  @DateTime DATETIME
) RETURNS INT AS BEGIN

  DECLARE @Dec DECIMAL(9,2)
  /* Convert to Days since 1900-01-01 */
  SET @Dec = CAST(@DateTime AS DECIMAL(9,2))
  /* Since 1900-01-01 is a Monday and Week start on Sunday, Add 1 */
  SET @Dec = @Dec + 1
  /* Floor of /7 is week # */
  RETURN FLOOR(@Dec/7)
END
GO