IF OBJECT_ID('[ActionGroupUsage_Slim]') IS NOT NULL DROP VIEW [ActionGroupUsage_Slim]
GO

CREATE VIEW [ActionGroupUsage_Slim]
AS
SELECT [ActionGroup_Id] = DPAG.[ActionGroup_Id],
       DPAG.[DeploymentPlanActionGroup_Id],
       DP.[DeploymentPlan_Name],
       A.[Application_Id],
       A.[Application_Name],
       AG.[ApplicationGroup_Id],
       AG.[ApplicationGroup_Name],
       E.[Environment_Id],
       E.[Environment_Name]

  FROM [DeploymentPlanActionGroups] DPAG
       INNER JOIN [DeploymentPlans] DP
               ON DP.[DeploymentPlan_Id] = DPAG.[DeploymentPlan_Id]
		LEFT JOIN [WorkflowSteps] WS
		       ON WS.[DeploymentPlan_Id] = DP.[DeploymentPlan_Id]
		LEFT JOIN [ApplicationWorkflows] AW
		       ON AW.[Workflow_Id] = WS.[Workflow_Id]
        LEFT JOIN [Applications] A
               ON A.[Application_Id] = AW.[Application_Id]
        LEFT JOIN [ApplicationGroups] AG
               ON A.[ApplicationGroup_Id] = AG.[ApplicationGroup_Id]
        LEFT JOIN [Environments] E
               ON E.[Environment_Id] = WS.[Environment_Id]

GO