
IF OBJECT_ID('[BuildSchedules_Extended]') IS NOT NULL DROP VIEW [BuildSchedules_Extended]
GO

CREATE VIEW [BuildSchedules_Extended] AS

    SELECT
           BS.[Schedule_Id]
          ,BS.[Schedule_Name]
          ,BS.[Application_Id]
          ,A.[Application_Name]
          ,BS.[Active_Indicator]
          ,BS.[CreatedBy_User_Name]
          ,BS.[CreatedOn_Date]
          ,BS.[ModifiedBy_User_Name]
          ,BS.[ModifiedOn_Date]
          ,BS.[Schedule_Type]
          ,BS.[StartTime_Minutes]
          ,BS.[EndTime_Minutes]
          ,BS.[DailyInterval_Minutes]
          ,BS.[Recurrence_Type]
          ,BS.[RecurrenceFrequency_Value]
          ,BS.[RecurrenceWeeklyDay_Mask]
          ,BS.[RecurrenceMonthlyDay_Value]
          ,BS.[RecurrenceMonthlyRelativity_Type]
          ,BS.[RecurrenceMonthlyRelativityDay_Type]
          ,BS.[RecurrenceMonthlyRelativityWeek_Type]
          ,BS.[RecurrenceMonthlyRelativityWeekDay_Value]
          ,BS.[Url_AllowedIP_CSV]
          ,BS.[Url_Username_Text]
          ,BS.[Url_Password_Text]
          ,BS.[SourceControl_Path_Name]
          ,BS.[SourceControl_Provider_Id]
          ,[SourceControl_Provider_Name] = P.[Provider_Name]
          ,BS.[SourceControl_QuietPeriod_Minutes]
          ,BS.ReleaseFilter_ReleaseType_Code
          ,BS.Releasefilter_Workflow_Id
          ,BS.[BuildImporter_Configuration]
		  ,BS.[LastExecution_Date]
          ,BS.[ReleaseFilter_Pipeline_Id]
          ,BS.[ReleaseFilter_Release_Number]

      FROM [BuildSchedules] BS

INNER JOIN [Applications] A
        ON A.[Application_Id] = BS.[Application_Id]

LEFT JOIN [Providers] P
        ON P.[Provider_Id] = BS.[SourceControl_Provider_Id]

GO
