IF OBJECT_ID('[DeploymentPlanActionGroups_Extended]') IS NOT NULL DROP VIEW [DeploymentPlanActionGroups_Extended]
GO

CREATE VIEW [DeploymentPlanActionGroups_Extended] AS

	SELECT DPAG.[DeploymentPlanActionGroup_Id],
	       DPAG.[DeploymentPlanActionGroup_Sequence],
	       DPAG.[DeploymentPlan_Id],
	       DPAG.[Deployable_Name],
	       [Active_Indicator] = DPAG.[Active_Indicator],
	       [ActionGroup_Name] = COALESCE(DPAG.[ActionGroup_Name], AG.[ActionGroup_Name]),
	       [ActionGroup_Description] = COALESCE(DPAG.[ActionGroup_Description], AG.[ActionGroup_Description]),
	       [Predicate_Configuration] = COALESCE(DPAG.[Predicate_Configuration], AG.[Predicate_Configuration]),
	       [Server_Id] = CASE WHEN DPAG.[Server_Variable_Name] IS NULL THEN COALESCE(DPAG.[Server_Id], AG.[Server_Id]) ELSE NULL END,
	       [Server_Variable_Name] = CASE WHEN DPAG.[Server_Id] IS NULL THEN COALESCE(DPAG.[Server_Variable_Name], AG.[Server_Variable_Name]) ELSE NULL END,
	       [ServerType_Code] = CASE WHEN DPAG.[Server_Variable_Name] IS NULL THEN S.[ServerType_Code] ELSE NULL END,
	       [Server_Name] = CASE WHEN DPAG.[Server_Variable_Name] IS NULL THEN S.[Server_Name] ELSE NULL END,
	       DPAG.[Iterate_Servers_Indicator],
	       DPAG.[Iterate_Deployables_Indicator],
	       DPAG.[Parallel_Indicator],
	       DPAG.[OnSuccess_DeploymentPlanActionGroup_Id],
		   [OnSuccess_DeploymentPlanActionGroup_Sequence] = S_DPAG.[DeploymentPlanActionGroup_Sequence],
		   [OnSuccess_DeploymentPlanActionGroup_Name] = COALESCE(S_DPAG.[ActionGroup_Name], S_AG.[ActionGroup_Name]),
	       DPAG.[OnFailure_DeploymentPlanActionGroup_Id],
		   [OnFailure_DeploymentPlanActionGroup_Sequence] = F_DPAG.[DeploymentPlanActionGroup_Sequence],
		   [OnFailure_DeploymentPlanActionGroup_Name] = COALESCE(F_DPAG.[ActionGroup_Name], F_AG.[ActionGroup_Name]),
	       DPAG.[OnFailure_Continue_Indicator],

	       [DeploymentPlanActionGroup_ActionGroup_Name] = DPAG.[ActionGroup_Name],
	       [DeploymentPlanActionGroup_ActionGroup_Description] = DPAG.[ActionGroup_Description],
	       [DeploymentPlanActionGroup_Predicate_Configuration] = DPAG.[Predicate_Configuration],
	       [DeploymentPlanActionGroup_ModifiedBy_User_Name] = DPAG.[ModifiedBy_User_Name],
	       [DeploymentPlanActionGroup_ModifiedOn_Date] = DPAG.[ModifiedOn_Date],
	       [DeploymentPlanActionGroup_Server_Id] = DPAG.[Server_Id],
	       [DeploymentPlanActionGroup_Server_Variable_Name] = DPAG.[Server_Variable_Name],

	       [ActionGroup_Id] = AG.[ActionGroup_Id],
	       [ActionGroup_CreatedBy_User_Name] = AG.[CreatedBy_User_Name],
	       [ActionGroup_CreatedOn_Date] = AG.[CreatedOn_Date],
	       [ActionGroup_ModifiedBy_User_Name] = AG.[ModifiedBy_User_Name],
	       [ActionGroup_ModifiedOn_Date] = AG.[ModifiedOn_Date],
	       [ActionGroup_ActionGroup_Name] = AG.[ActionGroup_Name],
	       [ActionGroup_Predicate_Configuration] = AG.[Predicate_Configuration],
	       [ActionGroup_ActionGroup_Description] = AG.[ActionGroup_Description],
	       [ActionGroup_Server_Id] = AG.[Server_Id],
	       [ActionGroup_Server_Variable_Name] = AG.[Server_Variable_Name],

	       [Referenced_Application_Id] = R_A.[Application_Id],
	       [Referenced_Application_Name] = R_A.[Application_Name],

	       [DeploymentPlanActionGroup_Count] = (SELECT COUNT(*)
						                         FROM [DeploymentPlanActionGroups] _DPAG
							                    WHERE _DPAG.[ActionGroup_Id] = DPAG.[ActionGroup_Id])

	  FROM	[DeploymentPlanActionGroups] DPAG
            INNER JOIN [ActionGroups] AG
                    ON DPAG.[ActionGroup_Id] = AG.[ActionGroup_Id]
             LEFT JOIN [Deployables] R_D
                    ON R_D.[Deployable_Name] = DPAG.[Deployable_Name]
                   AND R_D.[Application_Id] = DPAG.[Deployable_Application_Id]
             LEFT JOIN [Applications] R_A
                    ON R_A.[Application_Id] = R_D.[Application_Id]
             LEFT JOIN [Servers] S
                    ON S.[Server_Id] = COALESCE(DPAG.[Server_Id], AG.[Server_Id])
			 LEFT JOIN [DeploymentPlanActionGroups] S_DPAG
			        ON DPAG.[OnSuccess_DeploymentPlanActionGroup_Id] = S_DPAG.[DeploymentPlanActionGroup_Id]
			 LEFT JOIN [ActionGroups] S_AG
			        ON S_DPAG.[ActionGroup_Id] = S_AG.[ActionGroup_Id]
			 LEFT JOIN [DeploymentPlanActionGroups] F_DPAG
			        ON DPAG.[OnFailure_DeploymentPlanActionGroup_Id] = F_DPAG.[DeploymentPlanActionGroup_Id]
			 LEFT JOIN [ActionGroups] F_AG
			        ON F_DPAG.[ActionGroup_Id] = F_AG.[ActionGroup_Id]
GO
