IF OBJECT_ID('LogMessages_Extended') IS NOT NULL DROP VIEW LogMessages_Extended
GO

CREATE VIEW LogMessages_Extended AS
SELECT L.[LogMessage_Id]
      ,L.[Logged_Date]
      ,L.[Message_Text]
      ,L.[Category_Name]
      ,L.[Message_Level]
      ,L.[Details_Bytes]
      ,L.[Server_Id]
      ,S.[Server_Name]
      ,L.[Application_Id]
      ,A.[Application_Name]
      ,L.[Schedule_Id]
      ,BS.[Schedule_Name]
      ,L.[Requirement_Id]
      ,BPR.[Requirement_Description]
      ,[Requirement_Workflow_Id] = BPR.[Workflow_Id]
      ,L.[Provider_Id]
      ,P.[Provider_Name]
      ,L.[EventListener_Id]
      ,L.[ShowNotification_Indicator]
  FROM [LogMessages] L
       LEFT JOIN [Servers] S
              ON L.[Server_Id] = S.[Server_Id]       
       LEFT JOIN [Applications] A
              ON L.[Application_Id] = A.[Application_Id]
       LEFT JOIN [BuildSchedules] BS
              ON L.[Schedule_Id] = BS.[Schedule_Id]
       LEFT JOIN [BuildPromotionRequirements] BPR
              ON L.[Requirement_Id] = BPR.[Requirement_Id]
       LEFT JOIN [Providers] P
              ON L.[Provider_Id] = P.[Provider_Id]
       LEFT JOIN [EventListeners] EL
              ON L.[EventListener_Id] = EL.[EventListener_Id]

GO


