IF OBJECT_ID('[Scripts_Extended]') IS NOT NULL DROP VIEW [Scripts_Extended]
GO

CREATE VIEW [Scripts_Extended] AS

SELECT S.[Script_Id],
       S.[Script_Name],
       S.[Description_Text],
       S.[Active_Indicator],
       S.[AutoSync_Indicator],
       S.[ScriptType_Code],
       S.[CreatedBy_User_Name],
       S.[CreatedOn_Date],
       S.[ModifiedBy_User_Name],
       S.[ModifiedOn_Date],
       [LatestVersion_Number] = SV.[Version_Number],
       [LatestVersion_Bytes] = SV.[Script_Bytes]

  FROM [Scripts] S
        LEFT JOIN (SELECT _SV.[Script_Id],
                          [Version_Number] = MAX(_SV.[Version_Number])
                     FROM [ScriptVersions] _SV
                    GROUP BY _SV.[Script_Id]) _Latest_SV
               ON S.[Script_Id] = _Latest_SV.[Script_Id]
        LEFT JOIN [ScriptVersions] SV
               ON _Latest_SV.[Script_Id] = SV.[Script_Id]
              AND _Latest_SV.[Version_Number] = SV.[Version_Number]
GO
