IF OBJECT_ID('[VariableDefinitions_Extended]') IS NOT NULL DROP VIEW [VariableDefinitions_Extended]
GO

CREATE VIEW [VariableDefinitions_Extended] AS

SELECT VDEF.[VariableDefinition_Id]
      ,VDEF.[Variable_Name]
      ,VDEF.[Environment_Id]
      ,VDEF.[ServerRole_Id]
      ,VDEF.[Server_Id]
      ,VDEF.[ApplicationGroup_Id]
      ,VDEF.[Application_Id]
      ,VDEF.[Deployable_Id]
	  ,VDEF.[Release_Id]
      ,R.[Release_Number]
	  ,VDEF.[Build_Id]
      ,B.[Build_Number]
      ,VDEF.[Value_Text]
      ,VDEF.[Execution_Id]
	  ,VDEF.[Scope_Code]

      ,VDEC.[VariableDeclaration_Id]
      ,VDEC.[Scoped_Application_Id]
      ,VDEC.[Required_Indicator]
      ,VDEC.[Variable_Configuration]
      ,VDEC.[DefaultValue_Text]
      ,VDEC.[Scoped_Environment_Id]

      ,E.[Environment_Name]
      ,S.[Server_Name]
      ,AG.[ApplicationGroup_Name]
      ,A.[Application_Name]
      ,D.[Deployable_Name]
      ,VDEF.[Sensitive_Indicator]

  FROM [VariableDefinitions] VDEF
       LEFT JOIN [VariableDeclarations] VDEC
              ON VDEF.[Variable_Name] = VDEC.[Variable_Name]
             AND (VDEC.[Scope_Code] NOT IN ('R','B','P','X') OR
                  VDEF.[Application_Id] = VDEC.[Scoped_Application_Id])
             AND (VDEC.[Scope_Code] NOT IN ('P','X') OR
                  VDEF.[Environment_Id] = VDEC.[Scoped_Environment_Id])
             AND VDEC.[Scope_Code] = VDEF.[Scope_Code]
       LEFT JOIN [Applications] A
                 ON VDEF.[Application_Id] = A.[Application_Id]
	   LEFT JOIN [Releases] R
	             ON VDEF.[Release_Id] = R.[Release_Id]
	   LEFT JOIN [BuildPromotions] BP
	             ON VDEF.[Promotion_Id] = BP.[Promotion_Id]
	   LEFT JOIN [Builds] B
	             ON VDEF.[Build_Id] = BP.[Build_Id]
       LEFT JOIN [ApplicationGroups] AG
                 ON VDEF.[ApplicationGroup_Id] = AG.[ApplicationGroup_Id]
       LEFT JOIN [Environments] E
                 ON VDEF.[Environment_Id] = E.[Environment_Id]
       LEFT JOIN [Deployables] D
                 ON VDEF.[Deployable_Id] = D.[Deployable_Id]
       LEFT JOIN [Servers] S
                 ON VDEF.[Server_Id] = S.[Server_Id]
GO