EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'AdminEdit_PurgeArtifact',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Purges an artifact from the specified build.'
GO


IF OBJECT_ID('[AdminEdit_PurgeArtifact]') IS NOT NULL DROP PROCEDURE [AdminEdit_PurgeArtifact]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [AdminEdit_PurgeArtifact]
(
	@Application_Id INT,
	@Release_Number RELEASENUMBER,
	@Build_Number BUILDNUMBER,
	@Artifact_Name VARCHAR(50)
)
AS
BEGIN

    DELETE BA
	  FROM [BuildArtifacts] BA
	       INNER JOIN [Builds] B
		           ON B.[Build_Id] = BA.[Build_Id]
		   INNER JOIN [Releases] R
		           ON R.[Release_Id] = B.[Release_Id]
     WHERE R.[Application_Id] = @Application_Id
       AND R.[Release_Number] = @Release_Number
       AND B.[Build_Number] = @Build_Number
       AND BA.[Artifact_Name] = @Artifact_Name

END
GO

GRANT EXECUTE ON [AdminEdit_PurgeArtifact] TO [BuildMasterUser_Role]
