EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Applications_SearchApplications',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'Applications_Slim',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Searches for applications by application name and group name that contain the search term.'
GO


IF OBJECT_ID('[Applications_SearchApplications]') IS NOT NULL DROP PROCEDURE [Applications_SearchApplications]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Applications_SearchApplications]
(
    @SearchTerm_Text NVARCHAR(MAX)
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT * 
      FROM [Applications_Slim]
     WHERE [Active_Indicator] = 'Y'
       AND (NULLIF(@SearchTerm_Text, '') IS NULL
        OR CHARINDEX(@SearchTerm_Text, [Application_Name]) > 0
        OR CHARINDEX(@SearchTerm_Text, [ApplicationGroup_Name]) > 0)
	ORDER BY 
        CASE WHEN [ApplicationGroup_Id] IS NULL THEN 0 ELSE 1 END, 
        [ApplicationGroup_Name], 
        [Application_Name]

END
GO

GRANT EXECUTE ON [Applications_SearchApplications] TO [BuildMasterUser_Role]
