EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Builds_SetBuildNumber',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Sets the build number of a build.'
GO

IF OBJECT_ID('[Builds_SetBuildNumber]') IS NOT NULL DROP PROCEDURE [Builds_SetBuildNumber]
GO


SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Builds_SetBuildNumber]
(
	@Build_Id INT,
    @Build_Number BUILDNUMBER
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	DECLARE @Existing_Build_Number BUILDNUMBER
    DECLARE @Release_Id INT
    SELECT @Existing_Build_Number = [Build_Number],
           @Release_Id = [Release_Id]
      FROM [Builds] 
     WHERE [Build_Id] = @Build_Id

     IF @Existing_Build_Number <> @Build_Number
     BEGIN

        UPDATE [Builds]
           SET [Build_Number] = @Build_Number
         WHERE [Build_Id] = @Build_Id

        UPDATE [Issues]
           SET [OpenedOn_Original_Build_Number] = @Build_Number
         WHERE [Release_Id] = @Release_Id
           AND [OpenedOn_Original_Build_Number] = @Existing_Build_Number

        UPDATE [Issues]
           SET [ClosedOn_Original_Build_Number] = @Build_Number
         WHERE [Release_Id] = @Release_Id
           AND [ClosedOn_Original_Build_Number] = @Existing_Build_Number

       END       	

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Builds_SetBuildNumber] TO [BuildMasterUser_Role]
