EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'ConfigurationFiles_GetConfigurationFileVersion',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'ConfigurationFileVersions_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets a list of configuration file versions for a specified configuration file.'
GO

IF OBJECT_ID('[ConfigurationFiles_GetConfigurationFileVersion]') IS NOT NULL DROP PROCEDURE [ConfigurationFiles_GetConfigurationFileVersion]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [ConfigurationFiles_GetConfigurationFileVersion]
(
	@ConfigurationFile_Id INT,
	@Instance_Name VARCHAR(100) = NULL,
	@Version_Number INT = NULL
)
AS
BEGIN

	SET NOCOUNT ON

	IF @Version_Number IS NULL
	BEGIN

		SELECT @Version_Number = MAX([Version_Number])
		  FROM [ConfigurationFileVersions_Extended]
		 WHERE [ConfigurationFile_Id] = @ConfigurationFile_Id
		   AND [Instance_Name] = COALESCE(@Instance_Name, [Instance_Name])

	END	

	SELECT *
	  FROM [ConfigurationFileVersions_Extended]
	 WHERE [ConfigurationFile_Id] = @ConfigurationFile_Id
	   AND [Instance_Name] = COALESCE(@Instance_Name, [Instance_Name])
	   AND [Version_Number] = @Version_Number

END
GO

GRANT EXECUTE ON [ConfigurationFiles_GetConfigurationFileVersion] TO [BuildMasterUser_Role]
