EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Plans_DeleteDeploymentPlan',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Deletes a deployment plan.'
GO


IF OBJECT_ID('[Plans_DeleteDeploymentPlan]') IS NOT NULL DROP PROCEDURE [Plans_DeleteDeploymentPlan]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Plans_DeleteDeploymentPlan]
(
	@DeploymentPlan_Id INT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

 	DECLARE @TmpDeploymentPlanActionGroups TABLE ([DeploymentPlanActionGroup_Id] INT)
	INSERT @TmpDeploymentPlanActionGroups
	SELECT [DeploymentPlanActionGroup_Id] 
	  FROM [DeploymentPlanActionGroups]
	 WHERE [DeploymentPlan_Id] = @DeploymentPlan_Id

	 WHILE ((SELECT COUNT(*) FROM @TmpDeploymentPlanActionGroups) > 0 )
	 BEGIN
		DECLARE @DeploymentPlanActionGroup_Id INT
		SET @DeploymentPlanActionGroup_Id = (SELECT TOP 1 [DeploymentPlanActionGroup_Id] FROM @TmpDeploymentPlanActionGroups)

		EXEC [Plans_DeleteDeploymentPlanActionGroup] @DeploymentPlanActionGroup_Id

		DELETE @TmpDeploymentPlanActionGroups WHERE [DeploymentPlanActionGroup_Id] = @DeploymentPlanActionGroup_Id
	 END

    UPDATE [Workflows] 
       SET [Build_DeploymentPlan_Id] = NULL 
     WHERE [Build_DeploymentPlan_Id] = @DeploymentPlan_Id

    UPDATE [WorkflowSteps] 
       SET [DeploymentPlan_Id] = NULL
     WHERE [DeploymentPlan_Id] = @DeploymentPlan_Id

	DELETE [DeploymentPlans]
	 WHERE [DeploymentPlan_Id] = @DeploymentPlan_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Plans_DeleteDeploymentPlan] TO [BuildMasterUser_Role]
