EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'ReleaseTemplates_CreateOrUpdateTemplate',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ 'ReleaseTemplate_Id',
    /* Description_Text        */ 'Creates a release template or updates an existing one.'
GO

IF OBJECT_ID('[ReleaseTemplates_CreateOrUpdateTemplate]') IS NOT NULL DROP PROCEDURE [ReleaseTemplates_CreateOrUpdateTemplate]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [ReleaseTemplates_CreateOrUpdateTemplate]
(
	@Application_Id INT,
	@ReleaseTemplate_Name VARCHAR(50),
    @ReleaseTemplate_Configuration XML,
	@ReleaseTemplate_Id INT = NULL OUT
) AS
BEGIN

BEGIN TRY
	BEGIN TRANSACTION

    IF @ReleaseTemplate_Id IS NOT NULL
    BEGIN

        UPDATE [ReleaseTemplates]
           SET [ReleaseTemplate_Name] = @ReleaseTemplate_Name,
               [ReleaseTemplate_Configuration] = @ReleaseTemplate_Configuration
         WHERE [ReleaseTemplate_Id] = @ReleaseTemplate_Id

    END
    ELSE
    BEGIN

        INSERT INTO [ReleaseTemplates]
        (
            [Application_Id],
            [ReleaseTemplate_Name],
            [ReleaseTemplate_Configuration]
        )
        VALUES
        (
            @Application_Id,
            @ReleaseTemplate_Name,
            @ReleaseTemplate_Configuration
        )
        
        SET @ReleaseTemplate_Id = SCOPE_IDENTITY()

    END

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [ReleaseTemplates_CreateOrUpdateTemplate] TO [BuildMasterUser_Role]

