EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Releases_GetBuildExecutions',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'BuildExecutions_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the list of build executions for the specified release'
GO

IF OBJECT_ID('[Releases_GetBuildExecutions]') IS NOT NULL
	DROP PROCEDURE [Releases_GetBuildExecutions]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Releases_GetBuildExecutions]
(
	@Application_Id INT,
	@Release_Number RELEASENUMBER
) AS
BEGIN

	SET NOCOUNT ON

	SELECT *
	  FROM [BuildExecutions_Extended]
	 WHERE [Application_Id] = @Application_Id
	   AND [Release_Number] = @Release_Number

END
GO

GRANT EXECUTE ON [Releases_GetBuildExecutions] TO [BuildMasterUser_Role]