EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Releases_GetReleasesSlim',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'Releases_Slim',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets a list of releases that match the specified criteria with minimal join data.'
GO


IF OBJECT_ID('[Releases_GetReleasesSlim]') IS NOT NULL DROP PROCEDURE [Releases_GetReleasesSlim]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Releases_GetReleasesSlim]
(
	@Application_Id INT,
	@ReleaseStatus_Name VARCHAR(9) = NULL,
	@Release_Count INT = NULL
)
AS
BEGIN

	SET NOCOUNT ON

	IF @Release_Count IS NOT NULL
		SET ROWCOUNT @Release_Count

	SELECT * 
	  FROM [Releases_Slim]
     WHERE (@Application_Id IS NULL OR [Application_Id] = @Application_Id)
	   AND (@ReleaseStatus_Name IS NULL OR [ReleaseStatus_Name] = @ReleaseStatus_Name)
      ORDER BY [Release_Sequence] DESC
               

END
GO

GRANT EXECUTE ON [Releases_GetReleasesSlim] TO [BuildMasterUser_Role]
