EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'ScriptAssets_GetScriptByName',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataRow',
    /* DataTableNames_Csv      */ 'ScriptAssets',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the script with the specified name, searching from the specified application.'
GO

IF OBJECT_ID('[ScriptAssets_GetScriptByName]') IS NOT NULL DROP PROCEDURE [ScriptAssets_GetScriptByName]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [ScriptAssets_GetScriptByName]
(
	@ScriptAsset_Name VARCHAR(200),
	@Application_Id INT = NULL
)
AS
BEGIN

SET NOCOUNT ON

	SELECT TOP 1 *
	  FROM [ScriptAssets]
	 WHERE ([Application_Id] = @Application_Id OR [Application_Id] IS NULL)
	   AND [ScriptAsset_Name] = @ScriptAsset_Name
	 ORDER BY CASE WHEN [Application_Id] IS NULL THEN 1 ELSE 0 END

END
GO

GRANT EXECUTE ON [ScriptAssets_GetScriptByName] TO [BuildMasterUser_Role]