EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'UserConfiguration_SetValue',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Sets a user configuration value'
GO


IF OBJECT_ID('[dbo].[UserConfiguration_SetValue]') IS NOT NULL
	DROP PROCEDURE [dbo].[UserConfiguration_SetValue]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[UserConfiguration_SetValue]
(
	@User_Name USERNAME,
	@Key_Name VARCHAR(250),
	@Value_Text VARCHAR(MAX) = NULL OUT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	DELETE [UserConfiguration]
	 WHERE [User_Name] = @User_Name
	   AND [Key_Name] = @Key_Name

	IF (@Value_Text IS NOT NULL) 
		INSERT INTO [UserConfiguration]
			([User_Name], [Key_Name], [Value_Text])
		VALUES
			(@User_Name, @Key_Name, @Value_Text)

	--EXEC [Events_RaiseEvent] 'SYSCFG',NULL,@Key_Name


	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [dbo].[UserConfiguration_SetValue] TO [BuildMasterUser_Role]
GO
