EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Variables_GetAllVariableDefinitions',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'VariableDefinitions_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets all the variable definitions in the system.'
GO


IF OBJECT_ID('[Variables_GetAllVariableDefinitions]') IS NOT NULL DROP PROCEDURE [Variables_GetAllVariableDefinitions]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Variables_GetAllVariableDefinitions]
(
    @IncludeExecutionVariables_Indicator YNINDICATOR
)
AS
BEGIN

    SET NOCOUNT ON

    SELECT *
      FROM [VariableDefinitions_Extended]
      WHERE @IncludeExecutionVariables_Indicator = 'Y' OR [Execution_Id] IS NULL


END
GO

GRANT EXECUTE ON [Variables_GetAllVariableDefinitions] TO [BuildMasterUser_Role]